<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex40.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex40.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex40.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex40.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 40: Modules, Classes, and Objects</h1>
                <p>Python is called an &quot;object-oriented programming language.&quot;  This means there is a construct in Python called a class that lets you structure your software in a particular way.  Using classes, you can add consistency to your programs so that they can be used in a cleaner way. At least that's the theory.</p>
<p>I am now going to teach you the beginnings of object-oriented programming, classes, and objects using what you already know about dictionaries and modules.  My problem is that Object-Oriented Programming (OOP) is just plain weird.  You have to struggle with this, try to understand what I say here, type in the code, and in the next exercise I'll hammer it in.</p>
<p>Here we go.</p>
<div class="section" id="modules-are-like-dictionaries">
<h1>Modules Are Like Dictionaries</h1>
<p>You know how a dictionary is created and used and that it is a way to map one thing to another.  That means if you have a dictionary with a key &quot;apple&quot; and you want to get it then you do this:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="n">mystuff</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;apple&#39;</span><span class="p">:</span> <span class="s2">&quot;I AM APPLES!&quot;</span><span class="p">}</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="k">print</span> <span class="n">mystuff</span><span class="p">[</span><span class="s1">&#39;apple&#39;</span><span class="p">]</span>
</pre></div>
</td></tr></table><p>Keep this idea of &quot;get X from Y&quot; in your head, and now think about modules.  You've made a few so far, and you should know they are:</p>
<ol class="arabic simple">
<li>A Python file with some functions or variables in it ..</li>
<li>You import that file.</li>
<li>And you can access the functions or variables in that module with the <tt class="docutils literal">.</tt> (dot) operator.</li>
</ol>
<p>Imagine I have a module that I decide to name <tt class="docutils literal">mystuff.py</tt> and I put a function in it called <tt class="docutils literal">apple</tt>.  Here's the module <tt class="docutils literal">mystuff.py</tt>:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="c1"># this goes in mystuff.py</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="k">def</span> <span class="nf">apple</span><span class="p">():</span>
<a name="python--ex40a.py-idio.html-3"></a>    <span class="k">print</span> <span class="s2">&quot;I AM APPLES!&quot;</span>
</pre></div>
</td></tr></table><p>Once I have this code, I can use the module <tt class="docutils literal">MyStuff</tt> with <tt class="docutils literal">import</tt> and then access the <tt class="docutils literal">apple</tt> function:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">mystuff</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="n">mystuff</span><span class="o">.</span><span class="n">apple</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>I could also put a variable in it named <tt class="docutils literal">tangerine</tt>:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="k">def</span> <span class="nf">apple</span><span class="p">():</span>
<a name="python--ex40a.py-idio.html-2"></a>    <span class="k">print</span> <span class="s2">&quot;I AM APPLES!&quot;</span>
<a name="python--ex40a.py-idio.html-3"></a>
<a name="python--ex40a.py-idio.html-4"></a><span class="c1"># this is just a variable</span>
<a name="python--ex40a.py-idio.html-5"></a><span class="n">tangerine</span> <span class="o">=</span> <span class="s2">&quot;Living reflection of a dream&quot;</span>
</pre></div>
</td></tr></table><p>I can access that the same way:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">mystuff</span>
<a name="python--ex40a.py-idio.html-2"></a>
<a name="python--ex40a.py-idio.html-3"></a><span class="n">mystuff</span><span class="o">.</span><span class="n">apple</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-4"></a><span class="k">print</span> <span class="n">mystuff</span><span class="o">.</span><span class="n">tangerine</span>
</pre></div>
</td></tr></table><p>Refer back to the dictionary, and you should start to see how this is similar to using a dictionary, but the syntax is different.  Let's compare:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="n">mystuff</span><span class="p">[</span><span class="s1">&#39;apple&#39;</span><span class="p">]</span> <span class="c1"># get apple from dict</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="n">mystuff</span><span class="o">.</span><span class="n">apple</span><span class="p">()</span> <span class="c1"># get apple from the module</span>
<a name="python--ex40a.py-idio.html-3"></a><span class="n">mystuff</span><span class="o">.</span><span class="n">tangerine</span> <span class="c1"># same thing, it&#39;s just a variable</span>
</pre></div>
</td></tr></table><p>This means we have a <em>very</em> common pattern in Python:</p>
<ol class="arabic simple">
<li>Take a key=value style container.</li>
<li>Get something out of it by the key's name.</li>
</ol>
<p>In the case of the dictionary, the key is a string and the syntax is <tt class="docutils literal">[key]</tt>.  In the case of the module, the key is an identifier, and the syntax is <tt class="docutils literal">.key</tt>.  Other than that they are nearly the same thing.</p>
<div class="section" id="classes-are-like-modules">
<h2>Classes Are Like Modules</h2>
<p>You can think about a module as a specialized dictionary that can store Python code so you can access it with the <tt class="docutils literal">.</tt> operator.  Python also has another construct that serves a similar purpose called a class.  A class is a way to take a grouping of functions and data and place them inside a container so you can access them with the <tt class="docutils literal">.</tt> (dot) operator.</p>
<p>If I were to create a class just like the <tt class="docutils literal">mystuff</tt> module, I'd do something like this:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6
7</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="k">class</span> <span class="nc">MyStuff</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex40a.py-idio.html-2"></a>
<a name="python--ex40a.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex40a.py-idio.html-4"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">tangerine</span> <span class="o">=</span> <span class="s2">&quot;And now a thousand years between&quot;</span>
<a name="python--ex40a.py-idio.html-5"></a>
<a name="python--ex40a.py-idio.html-6"></a>    <span class="k">def</span> <span class="nf">apple</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex40a.py-idio.html-7"></a>        <span class="k">print</span> <span class="s2">&quot;I AM CLASSY APPLES!&quot;</span>
</pre></div>
</td></tr></table><p>That looks complicated compared to modules, and there is definitely a lot going on by comparison, but you should be able to make out how this is like a &quot;mini-module&quot; with <tt class="docutils literal">MyStuff</tt> having an <tt class="docutils literal">apple()</tt> function in it.  What is probably confusing is the <tt class="docutils literal">__init__()</tt> function and use of <tt class="docutils literal">self.tangerine</tt> for setting the <tt class="docutils literal">tangerine</tt> instance variable.</p>
<p>Here's why classes are used instead of modules:  You can take this <tt class="docutils literal">MyStuff</tt> class and use it to craft many of them, millions at a time if you want, and each one won't interfere with each other.  When you import a module there is only one for the entire program unless you do some monster hacks.</p>
<p>Before you can understand this though, you need to know what an &quot;object&quot; is and how to work with <tt class="docutils literal">MyStuff</tt> just like you do with the <tt class="docutils literal">mystuff.py</tt> module.</p>
</div>
<div class="section" id="objects-are-like-import">
<h2>Objects are Like Import</h2>
<p>If a class is like a &quot;mini-module,&quot; then there has to be a similar concept to <tt class="docutils literal">import</tt> but for classes.  That concept is called &quot;instantiate&quot;, which is just a fancy, obnoxious, overly smart way to say &quot;create.&quot;  When you instantiate a class what you get is called an object.</p>
<p>You instantiate (create) a class by calling the class like it's a function, like this:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="n">thing</span> <span class="o">=</span> <span class="n">MyStuff</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="n">thing</span><span class="o">.</span><span class="n">apple</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-3"></a><span class="k">print</span> <span class="n">thing</span><span class="o">.</span><span class="n">tangerine</span>
</pre></div>
</td></tr></table><p>The first line is the &quot;instantiate&quot; operation, and it's a lot like calling a function.  However, Python coordinates a sequence of events for you behind the scenes.  I'll go through these steps using the above code for <tt class="docutils literal">MyStuff</tt>:</p>
<ol class="arabic simple">
<li>Python looks for <tt class="docutils literal">MyStuff()</tt> and sees that it is a class you've defined.</li>
<li>Python crafts an empty object with all the functions you've specified in the class using <tt class="docutils literal">def</tt>.</li>
<li>Python then looks to see if you made a &quot;magic&quot; <tt class="docutils literal">__init__</tt> function, and if you have it calls that function to initialize your newly created empty object.</li>
<li>In the <tt class="docutils literal">MyStuff</tt> function <tt class="docutils literal">__init__</tt> I then get this extra variable <tt class="docutils literal">self</tt>, which is that empty object Python made for me, and I can set variables on it just like you would with a module, dictionary, or other object.</li>
<li>In this case, I set <tt class="docutils literal">self.tangerine</tt> to a song lyric and then I've initialized this object.</li>
<li>Now Python can take this newly minted object and assign it to the <tt class="docutils literal">thing</tt> variable for me to work with.</li>
</ol>
<p>That's the basics of how Python does this &quot;mini-import&quot; when you call a class like a function.  Remember that this is <em>not</em> giving you the class, but instead is using the class as a <em>blueprint</em> for building a copy of that type of thing.</p>
<p>Keep in mind that I'm giving you a slightly inaccurate idea for how these work so that you can start to build up an understanding of classes based on what you know about modules.  The truth is, classes and objects suddenly diverge from modules at this point.  If I were being totally honest, I'd say something more like this:</p>
<ul class="simple">
<li>Classes are like blueprints or definitions for creating new mini-modules.</li>
<li>Instantiation is how you make one of these mini-modules <em>and</em> import it at the same time.  &quot;Instantiate&quot; just means to create an object from the class.</li>
<li>The resulting created mini-module is called an object and you then assign it to a variable to work with it.</li>
</ul>
<p>At this point objects behave differently from modules and this should only serve as a way for you to bridge over to understanding classes and objects.</p>
</div>
<div class="section" id="getting-things-from-things">
<h2>Getting Things from Things</h2>
<p>I now have three ways to get things from things:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40a.py-idio.html-1"></a><span class="c1"># dict style</span>
<a name="python--ex40a.py-idio.html-2"></a><span class="n">mystuff</span><span class="p">[</span><span class="s1">&#39;apples&#39;</span><span class="p">]</span>
<a name="python--ex40a.py-idio.html-3"></a>
<a name="python--ex40a.py-idio.html-4"></a><span class="c1"># module style</span>
<a name="python--ex40a.py-idio.html-5"></a><span class="n">mystuff</span><span class="o">.</span><span class="n">apples</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-6"></a><span class="k">print</span> <span class="n">mystuff</span><span class="o">.</span><span class="n">tangerine</span>
<a name="python--ex40a.py-idio.html-7"></a>
<a name="python--ex40a.py-idio.html-8"></a><span class="c1"># class style</span>
<a name="python--ex40a.py-idio.html-9"></a><span class="n">thing</span> <span class="o">=</span> <span class="n">MyStuff</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-10"></a><span class="n">thing</span><span class="o">.</span><span class="n">apples</span><span class="p">()</span>
<a name="python--ex40a.py-idio.html-11"></a><span class="k">print</span> <span class="n">thing</span><span class="o">.</span><span class="n">tangerine</span>
</pre></div>
</td></tr></table></div>
<div class="section" id="a-first-class-example">
<h2>A First Class Example</h2>
<p>You should start seeing the similarities in these three key=value container types and probably have a bunch of questions.  Hang on with the questions, as the next exercise will hammer home your &quot;object-oriented vocabulary.&quot; In this exercise, I just want you to type in this code and get it working so that you have some experience before moving on.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex40.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Song</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex40.py-idio.html-2"></a>
<a name="python--ex40.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">lyrics</span><span class="p">):</span>
<a name="python--ex40.py-idio.html-4"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">lyrics</span> <span class="o">=</span> <span class="n">lyrics</span>
<a name="python--ex40.py-idio.html-5"></a>
<a name="python--ex40.py-idio.html-6"></a>    <span class="k">def</span> <span class="nf">sing_me_a_song</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex40.py-idio.html-7"></a>        <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">lyrics</span><span class="p">:</span>
<a name="python--ex40.py-idio.html-8"></a>            <span class="k">print</span> <span class="n">line</span>
<a name="python--ex40.py-idio.html-9"></a>
<a name="python--ex40.py-idio.html-10"></a><span class="n">happy_bday</span> <span class="o">=</span> <span class="n">Song</span><span class="p">([</span><span class="s2">&quot;Happy birthday to you&quot;</span><span class="p">,</span>
<a name="python--ex40.py-idio.html-11"></a>                   <span class="s2">&quot;I don&#39;t want to get sued&quot;</span><span class="p">,</span>
<a name="python--ex40.py-idio.html-12"></a>                   <span class="s2">&quot;So I&#39;ll stop right there&quot;</span><span class="p">])</span>
<a name="python--ex40.py-idio.html-13"></a>
<a name="python--ex40.py-idio.html-14"></a><span class="n">bulls_on_parade</span> <span class="o">=</span> <span class="n">Song</span><span class="p">([</span><span class="s2">&quot;They rally around tha family&quot;</span><span class="p">,</span>
<a name="python--ex40.py-idio.html-15"></a>                        <span class="s2">&quot;With pockets full of shells&quot;</span><span class="p">])</span>
<a name="python--ex40.py-idio.html-16"></a>
<a name="python--ex40.py-idio.html-17"></a><span class="n">happy_bday</span><span class="o">.</span><span class="n">sing_me_a_song</span><span class="p">()</span>
<a name="python--ex40.py-idio.html-18"></a>
<a name="python--ex40.py-idio.html-19"></a><span class="n">bulls_on_parade</span><span class="o">.</span><span class="n">sing_me_a_song</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex40.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex40.py
<a name="python--ex40.sh-idio-shint-pyg.html-2"></a><span class="go">Happy birthday to you</span>
<a name="python--ex40.sh-idio-shint-pyg.html-3"></a><span class="go">I don&#39;t want to get sued</span>
<a name="python--ex40.sh-idio-shint-pyg.html-4"></a><span class="go">So I&#39;ll stop right there</span>
<a name="python--ex40.sh-idio-shint-pyg.html-5"></a><span class="go">They rally around tha family</span>
<a name="python--ex40.sh-idio-shint-pyg.html-6"></a><span class="go">With pockets full of shells</span>
</pre></div></div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Write some more songs using this and make sure you understand that you're passing a list of strings as the lyrics.</li>
<li>Put the lyrics in a separate variable, then pass that variable to the class to use instead.</li>
<li>See if you can hack on this and make it do more things.  Don't worry if you have no idea how, just give it a try, see what happens.  Break it, trash it, thrash it, you can't hurt it.</li>
<li>Search online for &quot;object-oriented programming&quot; and try to overflow your brain with what you read.  Don't worry if it makes absolutely no sense to you.  Half of that stuff makes no sense to me too.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>Why do I need <tt class="docutils literal">self</tt> when I make <tt class="docutils literal">__init__</tt> or other functions for classes?</dt>
<dd>If you don't have <tt class="docutils literal">self</tt>, then code like <tt class="docutils literal">cheese = 'Frank'</tt> is ambiguous.  That code isn't clear about whether you mean the <em>instance's</em> <tt class="docutils literal">cheese</tt> attribute, <em>or</em> a local variable named <tt class="docutils literal">cheese</tt>.  With <tt class="docutils literal">self.cheese = 'Frank'</tt> it's very clear you mean the instance attribute <tt class="docutils literal">self.cheese</tt>.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex40.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex40.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
